import { PROP_CUSTOMIZE_TYPE } from "./constants";
export default function validateError(_ref) {
  let {
    componentName,
    customizeType
  } = _ref;

  if (!componentName) {
    throw new Error(`PropertyCustomizer => Component unique name is missing from the options`);
  }

  if (!Object.values(PROP_CUSTOMIZE_TYPE).includes(customizeType)) {
    throw new Error(`PropertyCustomizer => ${componentName} - Component prop customization type "${customizeType}" is not valid! \nIt accepts one of ["${Object.values(PROP_CUSTOMIZE_TYPE).join('", "')}"]`);
  }
}