import React, { useCallback } from 'react';
import { ContextOptimizer } from "../Responsive/helpers/ContextOptimizer";
import PropertyCustomizerContext from "./context/PropertyCustomizerContext";
import customizeProps from "../../../helpers/property-customizer/customize-props";
export default function PropertyCustomizer(Component, options) {
  function _PropertyCustomizer(props) {
    const getComponentProperties = useCallback(contextValue => {
      const {
        name: componentName
      } = options;
      return contextValue[componentName || Component.name];
    }, []);
    return /*#__PURE__*/React.createElement(ContextOptimizer, {
      Context: PropertyCustomizerContext,
      calculation: getComponentProperties
    }, _ref => {
      let {
        canOverride,
        props: newProps
      } = _ref;
      const {
        type,
        props: propNames
      } = options;
      const updatedProps = customizeProps({
        type,
        canOverride,
        propNames,
        oldProps: props,
        newProps
      });
      return /*#__PURE__*/React.createElement(Component, { ...updatedProps
      });
    });
  }

  _PropertyCustomizer.displayName = 'PropertyCustomizer';
  return _PropertyCustomizer;
}