"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = customizeProps;

var _constants = require("./constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// Option 1 - override property as common
function customizeProps(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? _constants.PROP_CUSTOMIZE_TYPE.allProps : _ref$type,
      _ref$override = _ref.override,
      override = _ref$override === void 0 ? false : _ref$override,
      _ref$propNames = _ref.propNames,
      propNames = _ref$propNames === void 0 ? [] : _ref$propNames,
      _ref$oldProps = _ref.oldProps,
      oldProps = _ref$oldProps === void 0 ? {} : _ref$oldProps,
      _ref$newProps = _ref.newProps,
      newProps = _ref$newProps === void 0 ? {} : _ref$newProps;

  switch (type) {
    case _constants.PROP_CUSTOMIZE_TYPE.allProps:
      return customizeAllProps({
        override: override,
        oldProps: oldProps,
        newProps: newProps
      });

    case _constants.PROP_CUSTOMIZE_TYPE.selectedProps:
      return customizeSelectedProps({
        override: override,
        propNames: propNames,
        oldProps: oldProps,
        newProps: newProps
      });

    case _constants.PROP_CUSTOMIZE_TYPE.excludedProps:
      return customizeAllPropsOtherThanExcluded({
        override: override,
        propNames: propNames,
        oldProps: oldProps,
        newProps: newProps
      });

    default:
      return oldProps;
  }
}

function customizeAllProps(_ref2) {
  var override = _ref2.override,
      oldProps = _ref2.oldProps,
      newProps = _ref2.newProps;

  if (override) {
    return _objectSpread(_objectSpread({}, oldProps), newProps);
  } else {
    return _objectSpread(_objectSpread({}, newProps), oldProps);
  }
}

function customizeSelectedProps(_ref3) {
  var override = _ref3.override,
      propNames = _ref3.propNames,
      oldProps = _ref3.oldProps,
      newProps = _ref3.newProps;
  return Object.keys(newProps).reduce(function (value, item) {
    if (propNames.includes(item)) {
      if (override) {
        value[item] = newProps[item];
      } else {
        if (!value.hasOwnProperty(item)) {
          value[item] = newProps[item];
        }
      }
    }

    return value;
  }, _objectSpread({}, oldProps));
}

function customizeAllPropsOtherThanExcluded(_ref4) {
  var override = _ref4.override,
      propNames = _ref4.propNames,
      oldProps = _ref4.oldProps,
      newProps = _ref4.newProps;
  return Object.keys(newProps).reduce(function (value, item) {
    if (!propNames.includes(item)) {
      if (override) {
        value[item] = newProps[item];
      } else {
        if (!value.hasOwnProperty(item)) {
          value[item] = newProps[item];
        }
      }
    }

    return value;
  }, _objectSpread({}, oldProps));
} // Option 2 - Override as symbol for each property that needs.
// export default function customizeProps({
//     type = PROP_CUSTOMIZE_TYPE.allProps,
//     propNames = [],
//     oldProps = {},
//     newProps = {}
// }) {
//     switch(type) {
//         case PROP_CUSTOMIZE_TYPE.allProps:
//             function isCustomizable() {
//                 return true;
//             }
//             return transformProps({
//                 isCustomizable,
//                 oldProps,
//                 newProps
//             });
//         case PROP_CUSTOMIZE_TYPE.selectedProps:
//             function isCustomizable(prop) {
//                 return propNames.includes(prop);
//             }
//             return transformProps({
//                 isCustomizable,
//                 oldProps,
//                 newProps
//             });
//         case PROP_CUSTOMIZE_TYPE.excludedProps:
//             function isCustomizable(prop) {
//                 return !propNames.includes(prop);
//             }
//             return transformProps({
//                 isCustomizable,
//                 oldProps,
//                 newProps
//             });
//         default:
//             return oldProps;
//     }
// }
// function transformProps({
//     isCustomizable,
//     oldProps,
//     newProps
// }) {
//     return Object.keys(newProps).reduce((value, item) => {
//         if(isCustomizable(item)) {
//             let override = item.startsWith('$') && item.endsWith('$');
//             if(override) {
//                 item = item.slice(1, item.length - 1);
//                 value[item] = newProps[item];
//             } else {
//                 if(!value.hasOwnProperty(item)) {
//                     value[item] = newProps[item];
//                 }
//             }
//         }
//         return value;
//     }, {...oldProps});
// }