"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = validateError;

var _constants = require("./constants");

function validateError(_ref) {
  var componentName = _ref.componentName,
      customizeType = _ref.customizeType;

  if (!componentName) {
    throw new Error("PropertyCustomizer => Component unique name is missing from the options");
  }

  if (!Object.values(_constants.PROP_CUSTOMIZE_TYPE).includes(customizeType)) {
    throw new Error("PropertyCustomizer => ".concat(componentName, " - Component prop customization type \"").concat(customizeType, "\" is not valid! \nIt accepts one of [\"").concat(Object.values(_constants.PROP_CUSTOMIZE_TYPE).join('", "'), "\"]"));
  }
}