"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = customizeProps;

var _constants = require("./constants");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function customizeProps(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? _constants.PROP_CUSTOMIZE_TYPE.allProps : _ref$type,
      _ref$canOverride = _ref.canOverride,
      canOverride = _ref$canOverride === void 0 ? false : _ref$canOverride,
      _ref$propNames = _ref.propNames,
      propNames = _ref$propNames === void 0 ? [] : _ref$propNames,
      _ref$oldProps = _ref.oldProps,
      oldProps = _ref$oldProps === void 0 ? {} : _ref$oldProps,
      _ref$newProps = _ref.newProps,
      newProps = _ref$newProps === void 0 ? {} : _ref$newProps;

  switch (type) {
    case _constants.PROP_CUSTOMIZE_TYPE.allProps:
      return customizeAllProps({
        canOverride: canOverride,
        oldProps: oldProps,
        newProps: newProps
      });

    case _constants.PROP_CUSTOMIZE_TYPE.selectedProps:
      return customizeSelectedProps({
        canOverride: canOverride,
        propNames: propNames,
        oldProps: oldProps,
        newProps: newProps
      });

    case _constants.PROP_CUSTOMIZE_TYPE.excludedProps:
      return customizeAllPropsOtherThanExcluded({
        canOverride: canOverride,
        propNames: propNames,
        oldProps: oldProps,
        newProps: newProps
      });

    default:
      return oldProps;
  }
}

function customizeAllProps(_ref2) {
  var canOverride = _ref2.canOverride,
      oldProps = _ref2.oldProps,
      newProps = _ref2.newProps;

  if (canOverride) {
    return _objectSpread(_objectSpread({}, oldProps), newProps);
  } else {
    return _objectSpread(_objectSpread({}, newProps), oldProps);
  }
}

function customizeSelectedProps(_ref3) {
  var canOverride = _ref3.canOverride,
      propNames = _ref3.propNames,
      oldProps = _ref3.oldProps,
      newProps = _ref3.newProps;
  return Object.keys(newProps).reduce(function (value, item) {
    if (propNames.includes(item)) {
      if (canOverride) {
        value[item] = newProps[item];
      } else {
        if (!value.hasOwnProperty(item)) {
          value[item] = newProps[item];
        }
      }
    }

    return value;
  }, _objectSpread({}, oldProps));
}

function customizeAllPropsOtherThanExcluded(_ref4) {
  var canOverride = _ref4.canOverride,
      propNames = _ref4.propNames,
      oldProps = _ref4.oldProps,
      newProps = _ref4.newProps;
  return Object.keys(newProps).reduce(function (value, item) {
    if (!propNames.includes(item)) {
      if (canOverride) {
        value[item] = newProps[item];
      } else {
        if (!value.hasOwnProperty(item)) {
          value[item] = newProps[item];
        }
      }
    }

    return value;
  }, _objectSpread({}, oldProps));
}