"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ComponentCustomizer;

var _react = _interopRequireWildcard(require("react"));

var _ContextOptimizer = require("../Responsive/helpers/ContextOptimizer");

var _ComponentCustomizerContext = _interopRequireDefault(require("./context/ComponentCustomizerContext"));

var _customizeProps = _interopRequireDefault(require("../../../helpers/component-customizer/customize-props"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// Option 1 - override property as common
function ComponentCustomizer(OrignalComponent, options) {
  function _ComponentCustomizer(props) {
    var getComponentProperties = (0, _react.useCallback)(function (contextValue) {
      var componentName = options.name;
      return contextValue[componentName];
    }, []);
    return /*#__PURE__*/_react["default"].createElement(_ContextOptimizer.ContextOptimizer, {
      Context: _ComponentCustomizerContext["default"],
      calculation: getComponentProperties
    }, function (componentData) {
      if (!componentData) {
        return /*#__PURE__*/_react["default"].createElement(OrignalComponent, props);
      }

      var NewComponent = componentData.Component,
          override = componentData.override,
          newProps = componentData.props;
      var type = options.type,
          propNames = options.props;
      var updatedProps = (0, _customizeProps["default"])({
        type: type,
        override: override,
        propNames: propNames,
        oldProps: props,
        newProps: newProps
      });
      var Component = NewComponent || OrignalComponent;
      return /*#__PURE__*/_react["default"].createElement(Component, updatedProps);
    });
  }

  _ComponentCustomizer.displayName = 'ComponentCustomizer';
  return _ComponentCustomizer;
} // Option 2 - Override as symbol for each property that needs.
// export default function ComponentCustomizer(OrignalComponent, options) {
//     function _ComponentCustomizer(props) {
//         const getComponentProperties = useCallback((contextValue) => {
//             const {
//                 name: componentName
//             } = options;
//             return contextValue[componentName];
//         }, []);
//         return (
//             <ContextOptimizer
//                 Context={ComponentCustomizerContext}
//                 calculation={getComponentProperties}
//             >
//                 {(componentData) => {
//                     if(!componentData) {
//                         return <OrignalComponent {...props} />
//                     }
//                     const {
//                         Component: NewComponent,
//                         props: newProps
//                     } = componentData;
//                     const {
//                         type,
//                         props: propNames
//                     } = options;
//                     const updatedProps = customizeProps({
//                         type,
//                         propNames,
//                         oldProps: props,
//                         newProps
//                     });
//                     const Component = NewComponent || OrignalComponent;
//                     return <Component {...updatedProps} />
//                 }}
//             </ContextOptimizer>
//         );
//     }
//     _ComponentCustomizer.displayName = 'ComponentCustomizer';
//     return _ComponentCustomizer;
// }