"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = PropertyCustomizer;

var _react = _interopRequireWildcard(require("react"));

var _ContextOptimizer = require("../Responsive/helpers/ContextOptimizer");

var _PropertyCustomizerContext = _interopRequireDefault(require("./context/PropertyCustomizerContext"));

var _customizeProps = _interopRequireDefault(require("../../../helpers/property-customizer/customize-props"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function PropertyCustomizer(Component, options) {
  function _PropertyCustomizer(props) {
    var getComponentProperties = (0, _react.useCallback)(function (contextValue) {
      var componentName = options.name;
      return contextValue[componentName || Component.name];
    }, []);
    return /*#__PURE__*/_react["default"].createElement(_ContextOptimizer.ContextOptimizer, {
      Context: _PropertyCustomizerContext["default"],
      calculation: getComponentProperties
    }, function (_ref) {
      var canOverride = _ref.canOverride,
          newProps = _ref.props;
      var type = options.type,
          propNames = options.props;
      var updatedProps = (0, _customizeProps["default"])({
        type: type,
        canOverride: canOverride,
        propNames: propNames,
        oldProps: props,
        newProps: newProps
      });
      return /*#__PURE__*/_react["default"].createElement(Component, updatedProps);
    });
  }

  _PropertyCustomizer.displayName = 'PropertyCustomizer';
  return _PropertyCustomizer;
}